=== modified file 'bzrlib/tests/test_tree.py'
--- bzrlib/tests/test_tree.py	2006-07-24 11:45:38 +0000
+++ bzrlib/tests/test_tree.py	2006-07-26 03:40:20 +0000
@@ -62,7 +62,7 @@
     calls = []
 
     def compare(self):
-        self.calls.append(('compare',))
+        self.calls.append(('compare', self.source, self.target))
     
     @classmethod
     def is_compatible(klass, source, target):
@@ -79,7 +79,7 @@
             InterTree.register_optimiser(RecordingOptimiser)
             tree = self.make_branch_and_tree('1')
             tree2 = self.make_branch_and_tree('2')
-            tree.compare(tree2)
+            tree.changes_from(tree2)
         finally:
             InterTree._optimisers = old_optimisers
-        self.assertEqual([('compare',)], RecordingOptimiser.calls)
+        self.assertEqual([('compare', tree2, tree)], RecordingOptimiser.calls)

=== modified file 'bzrlib/tree.py'
--- bzrlib/tree.py	2006-07-25 06:22:38 +0000
+++ bzrlib/tree.py	2006-07-26 03:40:20 +0000
@@ -51,14 +51,17 @@
     trees or versioned trees.
     """
     
-    def compare(self, other):
-        """Compare this tree with other.
+    def changes_from(self, other):
+        """Return a TreeDelta of the changes from other to this tree.
 
-        :param other: A tre to compare with.
+        :param other: A tree to compare with.
         The comparison will be performed by an InterTree object looked up on 
         self and other.
         """
-        return InterTree.get(self, other).compare()
+        # Martin observes that Tree.changes_from returns a TreeDelta and this
+        # may confuse people, because the class name of the returned object is
+        # a synonym of the object referenced in the method name.
+        return InterTree.get(other, self).compare()
     
     def conflicts(self):
         """Get a list of the conflicts in the tree.

